// 输入
var PageDI = {
  id: "PageDI", //页面id
  menu: "i18n.lan.menu.io", //所属菜单(一级菜单名)
  title: "i18n.lan.menu.PageDI", //标题（二级菜单名）
  parentIcon: "icon-me-io",
  icon: "icon-me-io", //图标
  refreshBtnCmd: "DUMP_GPIO,DUMP_TIMER", //刷新按钮指令
  saveBtn: true, //保存按钮
  el: [
    //控件
    {
      elname: "style",
      text: "#PageDI > label{min-width:150px;}",
    },
    {
      elname: "text",
      label: i18n.lan.PageDI.uploadTimer,
      endRow: true,
      attrs: {
        id: "PageDI_uploadTimer",
        dumpKey: "TSSPANM0",
        cmdKey: "SSPAN0<v>,32",
      },
    },
    {
      elname: "datagrid",
      rowCount: Device.getNodesCount("di"), //必选,行数
      data: {
        width: 300,
        columns: [
          [
            {
              //序号
              field: "index",
              width: 40,
              align: "center",
            },
            {
              //当前状态
              field: "state",
              formatter: Easyui.formatter.combobox,
              editor: new Easyui.editor.Combobox(
                i18n.lan.PageDI.stateItems,
                false
              ),
              dumpKey: "IOIS<n>",
              width: 80,
            },
            {
              //输入口类型
              field: "inputType",
              formatter: Easyui.formatter.combobox,
              editor: new Easyui.editor.Combobox(
                i18n.lan.PageDI.inputTypeItems,
                false
              ),
              dumpKey: "ITP<n>",
              // 下面有个隐藏文本框实现
              // cmdKey: "IOTP",
              // getValue: "PageDI_SetIOTP()",
              width: 160,
            },
          ],
        ],
      },
    },
    {
      //隐藏控件，用于保存指令IOTP
      elname: "text",
      attrs: {
        id: "PageDI_inputType",
        cmdKey: "IOTP",
        getValue: "PageDI_SetIOTP()",
        style: "visibility: hidden;",
      },
    },
  ],
};
CmdPage.add(PageDI); //添加到页面管理

function PageDI_SetIOTP() {
  let val = "";
  for (let i = 0; i < PageDI.dgData.rows.length; i++) {
    val += DatagridTool.getColumnVal("PageDI", i, "inputType");
  }
  // 输出口类型
  for (let i = 0; i < Device.nodes.do.count; i++) {
    // 直接使用1:输出
    val += "1";
  }
  return val;
}
